﻿init python:
    import random
    # import time
    # random.seed(time.clock())
    def chance(percent):
        c = random.randint(0, 100)
        if c < percent:
            return True
        else:
            return False
    def distance(a, b):
        if a >= b:
            result = a - b
        else:
            result = b - a
        return result
    renpy.music.register_channel("sfx1", "sfx", False)

    class sling_actor(renpy.Displayable):
        def __init__(self, image):
            super(renpy.Displayable,self).__init__()
            self.image = image

            self.parrent = None
            self.active = True
            self.is_enemy = False

            self.x = 0
            self.y = -600
            self.y_velocity = 1
            self.score = 0

        def render(self,width,height,st,at):
            img = self.image
            y_zoom = 1
            if self.active:
                if self.y < 1000:
                    self.y += self.y_velocity
                    if self.y > 600:
                        self.active = False

            if self.image == "sling_splash":
                self.y_velocity += .2
                if self.y_velocity < 0:
                    y_zoom = -1

            t = Transform(img, xanchor=0.5, yanchor=0.5, rotate = 0, zoom = 3, yzoom = y_zoom, nearest = True)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))
            
            renpy.redraw(self, 0)
            return rv

    class sling_class(renpy.Displayable):
        def __init__(self, images):
            super(renpy.Displayable,self).__init__()
            self.images = images
            self.current = images[0]
            self.player = None
            self.x = 0
            self.y = 0
            self.x_velocity = 0
            self.y_velocity = 0
            self.rotation = 0

            self.half_screen_width = 960
            self.half_screen_height = 540
            self.alive = True
            self.terminal_velocity = 550
            self.gravity = 2
            self.actors = []
            self.paused = False
            self.score = 0
            self.warnings = 0
            self.controled = True
            self.bounce_multiplier = 0
        def warn(self):
            self.warnings += 1
            self.score -= 10
            if self.warnings > 10:
                self.x_velocity = 0
                self.y_velocity = 0
                self.paused = False
                self.warnings = 0
                Play("sfx1", "sling/death.ogg")()
        def restart(self):
            self.x = 0
            self.y = 0
            self.x_velocity = 0
            self.y_velocity = 0
            self.alive = True
            self.actors = []
            self.paused = False
            self.score = 0
            self.warnings = 0
            self.controled = True
            self.bounce_multiplier = 1

        def spawn(self):
            actor = random.choice(
                [
                    ["sling_reward_small", 10],
                    ["sling_reward_medium", 25],
                    ["sling_reward_big", 50],
                    ["sling_spike", -50],
                    ["sling_splash", -100],
                ]
                )
            x = random.randint(-300,300)
            for i in self.actors:
                if not i.active:
                    if actor[0] ==  "sling_splash":
                        i.is_enemy = True
                        i.y_velocity = random.randint(-20, -10)
                        i.y = 550
                    elif actor[0] == "sling_spike":
                        i.is_enemy = True
                        i.y =-600
                        i.y_velocity = 1
                    else:
                        i.is_enemy = False
                        i.y =-600
                        i.y_velocity = 1

                    i.image = actor[0]
                    i.x = x
                    i.score = actor[1]
                    i.active = True
                    break
            else:
                a = sling_actor(actor[0])
                if actor[0] ==  "sling_splash":
                    a.is_enemy = True
                    a.y = 550
                    a.score = actor[1]
                    a.y_velocity = random.randint(-20, -10)
                elif actor[0] == "sling_spike":
                    a.is_enemy = True
                else:
                    a.score = actor[1]

                a.x = x
                self.actors.append(a)
        def start_sling(self, draggs):
            if self.controled:
                self.paused = True
                self.current = self.images[1]

        def sling(self, drags, drops):
            if self.alive:
                if self.controled:
                    Play("sfx1", "sling/bow.ogg")()
                    self.x_velocity = -(drags[0].x - 100)
                    self.y_velocity = -(drags[0].y - 100)
                    self.warnings = 0
                    self.bounce_multiplier = 1

                    drags[0].snap(100, 100, delay=.05)
                    self.paused = False
                    self.current = self.images[0]

        def render(self,width,height,st,at):
            img = self.current
            if self.alive:
                if self.y > self.half_screen_height-20:
                    Play("sound", "sling/drop.ogg")()
                    self.alive = False
                    renpy.restart_interaction()
                else:
                    if self.y_velocity < self.terminal_velocity:
                        self.y_velocity += self.gravity
                    

                    if (self.x_velocity < 0 and self.x < -396) or (self.x_velocity > 0 and self.x > 396):
                        self.x_velocity = -self.x_velocity
                        Play("sound", "sling/wall.ogg")()
                        self.bounce_multiplier *= 2

                        
                    if not self.paused:
                        self.rotation += self.x_velocity*.1
                        self.x += self.x_velocity*.1
                        self.y += self.y_velocity*.1

                    for i in self.actors:
                        if distance(i.y, self.y) < 48:
                            if i.active:
                                if distance(i.x, self.x) < 48:
                                    if i.is_enemy:
                                        renpy.play("sling/punch.ogg", "sound")
                                        i.active = False
                                        self.controled = False
                                        self.x_velocity = 0
                                        self.y_velocity = 0
                                        self.paused = True
                                        # i.y = 600
                                        self.current = self.images[1]
                                    else:
                                        i.active = False
                                        i.y = 600
                                        self.score += i.score*self.bounce_multiplier
                                        renpy.play("sling/got.ogg", "sfx1")
                                    # renpy.restart_interaction()
                                    break


            t = Transform(img, xanchor=0.5, yanchor=0.5, rotate = self.rotation, zoom = 3, nearest = True)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))
            
            renpy.redraw(self, 0)
            return rv

image sling_image = Crop((0,0,32,32), "sling")
image sling_image_2 = Crop((0,32,32,32), "sling")

image sling_reward_small = Crop((32,0,32,32), "sling")
image sling_reward_medium = Crop((64,0,32,32), "sling")
image sling_reward_big = Crop((96,0,32,32), "sling")

image sling_spike = Crop((32,32,32,32), "sling")
image sling_splash = Crop((64,32,32,32), "sling")

image sling_frame = Crop((96,32,32,32), "sling")
image sling_left_wall = Crop((96,64,32,32), "sling")
image sling_right_wall = Crop((0,64,32,32), "sling")
image sling_lave:
    Crop((0,96,32,32), "sling")
    .1
    Crop((32,96,32,32), "sling")
    .1
    Crop((64,96,32,32), "sling")
    .1
    Crop((96,96,32,32), "sling")
    .1
    repeat
default sling_ins = sling_class(["sling_image", "sling_image_2"])

screen sling_screen(g = sling_ins):
    modal True
    fixed xysize 1160,740 align .5,.5:
        at zoom(3, True)
        frame align .5,.5 padding 0,0 background "#202020":
            hbox spacing 290:
                vbox align .5,.5:
                    for i in range(12):
                        add "sling_left_wall"
                vbox align .5,.5:
                    for i in range(12):
                        add "sling_right_wall"
        drag:
            xysize 960,540 pos 100,100
            dragged g.sling
            activated g.start_sling
            frame:
                background None
    
    for i in g.actors:
        add i align .5,.5
    add g align .5,.5

    if g.alive and g.controled:
        timer random.random()+1 repeat True action Function(g.spawn)
    if g.paused:
        timer .1 repeat True action Function(g.warn)


    hbox align .5,1.0:
        at zoom(3)
        for i in range(9):
            add "sling_lave"
    frame:
        align .03,.04
        background Frame("sling_frame", 4,4) padding 20,20
        vbox :
            # text str(g.x)
            # text str(g.y)
            # text str(g.x_velocity)
            # text str(g.y_velocity)
            # text str(len(g.actors))
            text f"Score: [g.score]"
            text f"Bounce bonus: [g.bounce_multiplier]x"
        
    if not g.alive:
        hbox align .5,.5 spacing 10:
            button:
                background Frame("sling_frame", 4,4) padding 20,20
                text "Restart"
                action Function(g.restart)
            button:
                background Frame("sling_frame", 4,4) padding 20,20
                text "Done"
                action Return(g.score)

transform zoom(z, n = False):
    nearest n
    zoom z
label sling_example:
    show bg
    call screen sling_screen